
#include <windows.h>  
#include <commctrl.h>
#include "pressbtn.h"  



#if defined (WIN32)
	#define IS_WIN32 TRUE
#else
	#define IS_WIN32 FALSE
#endif

#define IS_NT      IS_WIN32 && (BOOL)(GetVersion() < 0x80000000)
#define IS_WIN32S  IS_WIN32 && (BOOL)(!(IS_NT) && (LOBYTE(LOWORD(GetVersion()))<4))
#define IS_WIN95   (BOOL)(!(IS_NT) && !(IS_WIN32S)) && IS_WIN32

HINSTANCE hInst;   // current instance

LPCTSTR lpszAppName = "MyApp";
LPCTSTR lpszTitle   = "TB_PRESSBUTTON"; 


BOOL RegisterWin95( CONST WNDCLASS* lpwc );


int APIENTRY WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
                      LPTSTR lpCmdLine, int nCmdShow)
{
   MSG      msg;
   HWND     hWnd; 
   WNDCLASS wc;

   wc.style         = CS_HREDRAW | CS_VREDRAW;
   wc.lpfnWndProc   = (WNDPROC)WndProc;       
   wc.cbClsExtra    = 0;                      
   wc.cbWndExtra    = 0;                      
   wc.hInstance     = hInstance;              
   wc.hIcon         = LoadIcon (hInstance, lpszAppName); 
   wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
   wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
   wc.lpszMenuName  = lpszAppName;              
   wc.lpszClassName = lpszAppName;              

   if ( IS_WIN95 )
   {
      if ( !RegisterWin95( &wc ) )
         return( FALSE );
   }
   else if ( !RegisterClass( &wc ) )
      return( FALSE );

   hInst = hInstance; 

   hWnd = CreateWindow( lpszAppName, 
                        lpszTitle,    
                        WS_OVERLAPPEDWINDOW, 
                        CW_USEDEFAULT, 0, 
                        CW_USEDEFAULT, 0,  
                        NULL,              
                        NULL,              
                        hInstance,         
                        NULL               
                      );

   if ( !hWnd ) 
      return( FALSE );

   ShowWindow( hWnd, nCmdShow ); 
   UpdateWindow( hWnd );         

   while( GetMessage( &msg, NULL, 0, 0) )   
   {
      TranslateMessage( &msg ); 
      DispatchMessage( &msg );  
   }

   return( msg.wParam ); 
}


BOOL RegisterWin95( CONST WNDCLASS* lpwc )
{
   WNDCLASSEX wcex;

   wcex.style         = lpwc->style;
   wcex.lpfnWndProc   = lpwc->lpfnWndProc;
   wcex.cbClsExtra    = lpwc->cbClsExtra;
   wcex.cbWndExtra    = lpwc->cbWndExtra;
   wcex.hInstance     = lpwc->hInstance;
   wcex.hIcon         = lpwc->hIcon;
   wcex.hCursor       = lpwc->hCursor;
   wcex.hbrBackground = lpwc->hbrBackground;
   wcex.lpszMenuName  = lpwc->lpszMenuName;
   wcex.lpszClassName = lpwc->lpszClassName;

   // Added elements for Windows 95.
   //...............................
   wcex.cbSize = sizeof(WNDCLASSEX);
   wcex.hIconSm = LoadImage(wcex.hInstance, lpwc->lpszClassName, 
                            IMAGE_ICON, 16, 16,
                            LR_DEFAULTCOLOR );
			
   return RegisterClassEx( &wcex );
}

// Toolbar buttons. 
//.................
TBBUTTON tbButtons[] = 
{ 
    { 0, IDM_TEST1, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0L, 0},
    { 1, IDM_TEST2, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0L, 0},
    { 2, IDM_TEST3, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0L, 0},
    { 3, IDM_TEST4, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0L, 0},
}; 


LRESULT CALLBACK WndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
static HWND hToolWnd   = NULL;

   switch( uMsg )
   {
      case WM_CREATE :
              // Initialize the common control library
              // and create the toolbar.
              //.......................................
              InitCommonControls();

              hToolWnd = CreateWindowEx( 0, TOOLBARCLASSNAME, NULL, 
                                         WS_CHILD | WS_BORDER | WS_VISIBLE, 
                                         0, 0, 0, 0, hWnd, (HMENU)101, hInst, NULL);

              if ( hToolWnd )
              {
                 HBITMAP     hBmp;
                 TBADDBITMAP tb;
                 int index, stdidx;

                 // Set the size of the TBBUTTON structure.
                 //........................................
                 SendMessage(hToolWnd, TB_BUTTONSTRUCTSIZE, sizeof(TBBUTTON), 0); 

                 // Load bitmap to add to the toolbar.
                 //...................................
                 hBmp = CreateMappedBitmap( hInst, 100, 0, NULL, 0 );

                 tb.hInst = NULL;
                 tb.nID   = (UINT) hBmp;
                 stdidx = SendMessage(hToolWnd, TB_ADDBITMAP, 4, (LPARAM)&tb);

                 for (index = 0; index < 4; index++)
                    tbButtons[index].iBitmap += stdidx;

                 // Add the buttons to the toolbar.
                 //................................
                 SendMessage(hToolWnd, TB_ADDBUTTONS, 4, (LONG) &tbButtons[0]);
              }
              break;

      case WM_COMMAND :
              switch( LOWORD( wParam ) )
              {
                 case IDM_TESTMENU1 :
                 case IDM_TESTMENU2 :
                 case IDM_TESTMENU3 :
                 case IDM_TESTMENU4 :
                        {
                           BOOL bPressed;

                           bPressed = SendMessage( hToolWnd, 
                                                   TB_ISBUTTONPRESSED,
                                                   LOWORD( wParam )-IDM_TOOLBASE,
                                                   0 );

                           // Press/Unpress the toolbar button.
                           //...................................
                           SendMessage(hToolWnd, TB_PRESSBUTTON, 
                                       LOWORD( wParam )-IDM_TOOLBASE,
                                       !bPressed );
                        }
                        break;

                 case IDM_ABOUT :
                        DialogBox( hInst, "AboutBox", hWnd, (DLGPROC)About );
                        break;

                 case IDM_EXIT :
                        DestroyWindow( hWnd );
                        break;
              }
              break;
      
      case WM_DESTROY :
              PostQuitMessage(0);
              break;

      default :
            return( DefWindowProc( hWnd, uMsg, wParam, lParam ) );
   }

   return( 0L );
}


LRESULT CALLBACK About( HWND hDlg,           
                        UINT message,        
                        WPARAM wParam,       
                        LPARAM lParam)
{
   switch (message) 
   {
       case WM_INITDIALOG: 
               return (TRUE);

       case WM_COMMAND:                              
               if (   LOWORD(wParam) == IDOK         
                   || LOWORD(wParam) == IDCANCEL)    
               {
                       EndDialog(hDlg, TRUE);        
                       return (TRUE);
               }
               break;
   }

   return (FALSE); 
}
